
( function ( blocks, element, blockEditor ) {
    const el = element.createElement,
        registerBlockType = blocks.registerBlockType,
        ServerSideRender = PgServerSideRender,
        InspectorControls = blockEditor.InspectorControls,
        useBlockProps = blockEditor.useBlockProps;
        
    const {__} = wp.i18n;
    const {ColorPicker, TextControl, ToggleControl, SelectControl, Panel, PanelBody, Disabled, TextareaControl, BaseControl} = wp.components;
    const {useSelect} = wp.data;
    const {RawHTML, Fragment} = element;
   
    const {InnerBlocks, URLInputButton, RichText} = wp.blockEditor;
    const useInnerBlocksProps = blockEditor.useInnerBlocksProps || blockEditor.__experimentalUseInnerBlocksProps;
    
    const propOrDefault = function(val, prop, field) {
        if(block.attributes[prop] && (val === null || val === '')) {
            return field ? block.attributes[prop].default[field] : block.attributes[prop].default;
        }
        return val;
    }
    
    const block = registerBlockType( 'portfolio/counter', {
        apiVersion: 2,
        title: 'Counter',
        icon: 'block-default',
        category: 'pagesections',
        keywords: [],
        supports: {color: {background: false,text: false,gradients: false,link: false,},typography: {fontSize: false,},anchor: false,align: false,},
        attributes: {
            number: {
                type: 'text',
                default: `10+`,
            },
            label: {
                type: 'text',
                default: `Years of Experience`,
            }
        },
        example: { attributes: { number: `10+`, label: `Years of Experience` } },
        edit: function ( props ) {
            const blockProps = useBlockProps({ className: 'col-md-4' });
            const setAttributes = props.setAttributes; 
            
            
            const innerBlocksProps = null;
            
            
            return el(Fragment, {}, [
                el('div', { ...blockProps }, el('div', { className: 'bg-light h-100 p-4 rounded-1 shadow-sm' }, [el(RichText, { tagName: 'h2', className: 'display-4 fw-bold text-primary', value: propOrDefault( props.attributes.number, 'number' ), onChange: function(val) { setAttributes( {number: val }) }, withoutInteractiveFormatting: true, allowedFormats: [] }), el(RichText, { tagName: 'h3', className: 'fw-bold h6 text-secondary', value: propOrDefault( props.attributes.label, 'label' ), onChange: function(val) { setAttributes( {label: val }) }, withoutInteractiveFormatting: true, allowedFormats: [] })])),                        
                
                    el( InspectorControls, {},
                        [
                            
                            el(Panel, {},
                                el(PanelBody, {
                                    title: __('Block properties')
                                }, [
                                    
                                    el(TextControl, {
                                        value: props.attributes.number,
                                        help: __( '' ),
                                        label: __( 'Number' ),
                                        onChange: function(val) { setAttributes({number: val}) },
                                        type: 'text'
                                    }),
                                    el(TextControl, {
                                        value: props.attributes.label,
                                        help: __( '' ),
                                        label: __( 'Label' ),
                                        onChange: function(val) { setAttributes({label: val}) },
                                        type: 'text'
                                    }),    
                                ])
                            )
                        ]
                    )                            

            ]);
        },

        save: function(props) {
            const blockProps = useBlockProps.save({ className: 'col-md-4' });
            return el('div', { ...blockProps }, el('div', { className: 'bg-light h-100 p-4 rounded-1 shadow-sm' }, [el(RichText.Content, { tagName: 'h2', className: 'display-4 fw-bold text-primary', value: propOrDefault( props.attributes.number, 'number' ) }), el(RichText.Content, { tagName: 'h3', className: 'fw-bold h6 text-secondary', value: propOrDefault( props.attributes.label, 'label' ) })]));
        }                        

    } );
} )(
    window.wp.blocks,
    window.wp.element,
    window.wp.blockEditor
);                        
